extends CanvasLayer

@export var subtitle : Label
@export var subtitle_animator : AnimationPlayer

@export var tracking_choice : OptionButton

signal tracking_mode_request(tracking_mode : UltraleapTypes.TrackingMode)

func _ready():
	print("ready")
	subtitle_animator.play("show_subtitle")
	subtitle_animator.seek(0, true)
	subtitle_animator.stop(false)

func play_floating_bottom_text(text : String):
	subtitle.text = text
	subtitle_animator.play("show_subtitle")

func tracking_mode_changed(tracking_mode):
	tracking_choice.selected = tracking_mode

func button_item_selected(index):
	var error = emit_signal("tracking_mode_request", index)
	if error != OK:
		printerr("Failure emitting the signal for tracking mode request")
