@tool
extends TextureRect

enum Side { Left, Right }

@export var side : Side = Side.Left
@export var tracker : UltraleapHandTracking
@export var img : Image
@export var data_img : Image

@onready var bg_data : PackedByteArray = PackedByteArray()
@onready var data : PackedByteArray

var last_size : Vector2i = Vector2i(0, 0)
	
func _process(_delta):
	var view_size : Vector2i = get_viewport().size
	view_size.x /= 2
	
	var length = min(view_size.x, view_size.y)
	
	if (view_size != last_size):
		print("Size changed!")
		#bg_data = PackedByteArray()
		var _data_size = bg_data.resize((int)(size.x * size.y))
		bg_data.fill(1)
	
		img.set_data(view_size.x, view_size.y, false, Image.FORMAT_L8, bg_data)
		last_size = view_size

	if not Engine.is_editor_hint():
		var image : UltraleapImage
		
		if tracker.tracking_mode == UltraleapTypes.TrackingMode.Desktop:
			image = tracker.get_right_image() if side == Side.Left else tracker.get_left_image()
		else:
			image = tracker.get_right_image() if side == Side.Right else tracker.get_left_image()
			
		flip_h = tracker.tracking_mode == UltraleapTypes.TrackingMode.Desktop

		data = image.get_data()

		if data.size() == 384 * 384:
			data_img.set_data(384, 384, false, Image.FORMAT_L8, data)
			data_img.resize(length, length, Image.INTERPOLATE_NEAREST)

			var x : int = view_size.x - length if side == Side.Left else 0
			var y : int = (view_size.y - length) / 2
			
			img.blit_rect(data_img, Rect2i(0, 0, length, length), Vector2(x, y))

	texture.set_image(img)
